# SRUP

## Secure Remote Update Protocol
The Secure Remote Update Protocol (SRUP) is a secure & confirmable command-and-control (C2) protocol for the Internet of Things (IoT), based on MQTT.

SRUP is designed to provide an easy way to communicate details of a required software update to an IoT device – but it's not limited just software updates; the protocol can be extended to support any type of C2 message.

**This software is the output of PhD research; and whilst appropriate due diligence has been carried out in terms of quality assurance – this software is not a formal Dstl output; please see the terms of release as outlined in the MIT Licence within this repository..**

Further details of the protocol may be found in the papers:
* SRUP: The Secure Remote Update Protocol (published at the IEEE World Forum on the Internet of Things, 12th December 2016) - http://ieeexplore.ieee.org/document/7845397/

* Extensions and Enhancements to "the Secure Remote Update Protocol" (published in Volume 9, issue 4 of the Journal 'Future Internet') - http://www.mdpi.com/1999-5903/9/4/59

* pySRUP – Simplifying Secure Communications for Command & Control in the Internet of Things (published at the 5th IEEE World Forum on the Internet of Things, 15-18 April 2019) - https://ieeexplore.ieee.org/document/8767205

* Enabling the Secure Use of Dynamic Identity for the Internet of Things—Using the Secure Remote Update Protocol (published in Volume 12, issue 8 of the Journal 'Future Internet') - https://www.mdpi.com/1999-5903/12/8/138

* Enabling Secure Guest Access for Command-and-Control of Internet of Things Devices (published in Volume 2, issue 2 of the Journal 'IoT') -  https://www.mdpi.com/2624-831X/2/2/13

The latest release of the source code can be accessed via [![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.4575539.svg)](https://zenodo.org/badge/latestdoi/62746329) 
